<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<!-- $Id: SeeCfsDthResults.php,v 1.8 2002/06/16 09:59:13 queinnec Exp $ -->
<?php 
// A single page to present 
//         a) the global results for all students
//         b) the results of a single student
// Copy this file, edit it to your needs and make it visible by the students.

//******************************************************* Parameters
// Where's the css file ?
$css = "../licence/public/licence-css.php";

// Who should be mailed in case of problems ?
$email = "Christian.Queinnec@lip6.fr";

// Database parameters:
// The name of the database:
$db_name = 'licence';
// The name of the DB user to incarnate when connecting to the db:
$db_user = 'php';
$db_password ='';
// Prefix for the SQL tables (normally the value of OTHER_DB_PREFIX):
$db_prefix = 'CFS2002jun05am';

// Where are the deliverables (the tgz) ?
// Here, they are supposed to be in the ./students/ subdirectory

$wwwPrefix = dirname($PHP_SELF);
$tgzPrefix = $wwwPrefix . "/students/";

//  Where are the associated logs when marked. This directory should contain
// uuid subdirectories with a file named all.html. 
// Here, they are supposed to be in the ./logs/ subdirectory.

$uuidPrefix = $wwwPrefix . "/logs/";

// Where are the students' photos (requires a password for
// www.ufr-info-p6.jussieu.fr):
$imagePrefix = "http://www.ufr-info-p6.jussieu.fr/trombi/2001/"
  . "affiche/affiche_image_login.php3?login";

// The title of the page that presents all students' marks
$title1 = 'Notes CFS 05 juin 2002 matin';
$title2 = $title1 . " (par tudiant)";

// Statistical bias
$bias = 1.;

//******************************************************* End of parameters
// Normally, no more modification beyond that point.
include("libcommon.php");
include("libnote.php");
include("libstatecct.php");
include("libobj.php");
include("libcfs2.php");
?>

<html><head>
   <LINK rel=stylesheet type="text/css" href="<?php echo $css ?>">
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
   <META NAME="GENERATOR" CONTENT="Emacs">
   <META NAME="Author" CONTENT="Christian.Queinnec@lip6.fr">
   <META NAME="Keywords" CONTENT="UPMC Licence cct">
   <META NAME="description" CONTENT="UPMC Licence CCT">

<?php
// subclass Student to add the session field:

// If the student's id is sent, present these student's mark otherwise
// present all students' marks:

$id = $HTTP_GET_VARS["id"];
if ( $id ) {
     $id = sanitize_number($id); 
     // Present the marks of this precise student:
?>

   <title><?php echo $title2 ?></title>
</head><body><?php generate_common_bar($title2); ?>

<h1> <?php echo $title2 ?></h1>

<!-- Ici on peut inserer un texte pour l etudiant particulier -->

<?php
// If we have a login, display the student's photo
$login = $HTTP_GET_VARS["login"];
if ( $login ) {
     $login = sanitize_login($login);
     $photo = "<img src=\"$imagePrefix=$login\" width=80>";
} else {
     $photo = '';
}
?>

<p align='center'><table align="center" style="font-size: 100%;" border=0>
<table><tr><td><?php echo $photo ?></td><td><table border=1><tr>
<th>Nom</th><th>Soumission</th><?php
foreach ($lesQuestions as $question) {
     echo "<th>$question</th>";
}
?></tr>

<?php
$lesSoumissions =& extract_cfs_submission($db_prefix, $id, $lesQuestions);
usort($lesSoumissions, "tgz_before");
foreach ($lesSoumissions as $ss) {
     $url = $uuidPrefix . $ss->uuid . "/all.html";
     echo "<tr><td>" . $ss->name . "</td><td><a href=\"" . 
          $tgzPrefix . $ss->tgz . "\">" . shorten_tgz($ss->tgz). 
          "</a></td>";
     $total = 0.0;
     foreach ($lesQuestions as $question) {
          $total += $ss->notes[$question];
          echo "<td><a href=\"$url#$question\" target=\"_blank\"> "
               . $ss->notes[$question] . "</a></td>";
     }
     echo "</tr>\n";
}

?></table></p></td></tr></table>

<?php
} else { 
     // Present all students' marks
?>

   <title><?php echo $title1 ?></title>
</head><body><?php generate_common_bar($title1); ?>

<h1> <?php echo $title1 ?></h1>

<!-- Ici on peut inserer un texte rappelant l examen -->

<p align="center"><table align="center" style="font-size: 100%;" border=1>
<th>Numro</th><th>Nom, prnom</th><?php
foreach ($lesQuestions as $question) {
     echo "<th>$question</th>";
}
?><th>Total</th></tr>

<?php
$lesEtudiants =& extract_all_students_marks($db_prefix);
usort($lesEtudiants, "student_alpha_order");

$allMarks = array();
foreach ($lesEtudiants as $s) {
     echo "<tr><td>" . $s->id . "</td><td>" 
          . generate_cfs_details($s) . "</td>";
     $total = 0.0;
     foreach ($lesQuestions as $question) {
          $mark = $s->notes[$question];
          $total += $mark;
          echo "<td>", $mark, "</td>";
     }
     // FUTURE ou prendre la note definitive dans la table Mark ???
     $total = min(20.0, ceil($bias * $total));
     echo "<td align=\"right\">", $total, "</td></tr>\n";
     // Record for the 'record=1' query parameter:
     $s->final = $total;
     // For statistics
     $allMarks[] = $total;
}

?></table></p>

<p>
Cette page contient les notes de <?php echo count($lesEtudiants) ?> 
tudiants. <?php 
         // Display statistics
if ( $HTTP_GET_VARS['stats'] ) {
     $results =& computeStatistics($allMarks);
     echo "La moyenne (aprs arrondi) est de ", round($results[0], 2), 
          " et l'cart-type de ", round($results[1], 2), ". ";
     echo "La correction est de $bias.";
};
        // Record final mark in database
if ( $HTTP_GET_VARS['record'] ) {
     if ( is_authorized($PHP_AUTH_USER, $db_prefix) ) {
          $connection = open_connection_to_licence_db();
          $query = "begin";
          $request = execute_request($connection, $query);
          foreach ($lesEtudiants as $s) {
               $query = "update ${db_prefix}_student
set final = $s->final
where login = '$s->login';";
               $request = execute_request($connection, $query);
          }
          // Use the basic pg_exec to produce a better report:
          if ( pg_exec($connection, "commit") ) {
               echo "Les notes finales ont t enregistres.";
          } else {
               echo "PROBLME: les modifications n'ont pu tre enregistres!";
               echo pg_ErrorMessage($connection);
               exit;
          }
     } else { ?>
Vous n'tes pas l'enseignant responsable de <?php echo $db_prefix?>, 
vous ne pouvez donc pas enregistrer les notes des tudiants.
<?php
     }
};
?></p>

<?php
} ?>

<hr>
<a href="mailto:<?php echo $email ?>">Remarques?</a>
&nbsp;&nbsp;&nbsp;<tt><?php 
echo "\$Id: SeeCfsDthResults.php,v 1.8 2002/06/16 09:59:13 queinnec Exp $" ?></tt><br>
Extrait de la base  licence  le <?php echo date("j F Y  G:i:s\.") ?>
</body></html>
