
select s.studentid || ';' || 
       s.lastname || ', ' || lower(s.firstname) || 
       ';' || m.mark
from student s, mark m
where s.studentid = m.studentid
  and m.epreuveid = (select e.moduleid
                     from epreuve e
                     where e.shortname = 'cct2'
                       and e.term = '2002fev' )
order by s.lastname, s.firstname;
