<?php 
// $Id: SeeCfsDthFile.php,v 1.1 2002/06/13 08:54:47 queinnec Exp queinnec $
// A single page to extract a file from a delivery.
// The URL should look like:
//       SeeCfsDthFile.php?login=p6lip123&file=foo.c

include("libcommon.php");

$login = $HTTP_GET_VARS["login"];
if ( $login ) {
     $login = sanitize_login($login); 
} else {
     header("text/html");
     report_error_and_die("Missing login");
}

$filename = $HTTP_GET_VARS["file"];
if ( $filename ) {
     $filename = escapeshellarg($filename);
} else {
     header("text/html");
     report_error_and_die("Missing file");
}

$tgz = dirname($SCRIPT_FILENAME) . "/students/${login}_NOBODY_001.tar.gz";
if ( !file_exists($tgz) ) {
     header("text/html");
     report_error_and_die("No such tgz");
};

header("text/plain");
$code = 0;
// lire la derniere soumission                                  FUTURE
$command = "tar --to-stdout -xzf $tgz $filename";
passthru($command, $code);
if ( $code != 0 ) {
     echo "Je n'arrive pas a trouver ce fichier.";
};

?>
