#! /usr/bin/perl

my $size = shift;
my $file = shift;
my $count = 0;

# Transform the unit (k or M) into the right number:
$size =~ s/k$/000/i;
$size =~ s/m$/000000/i;

if ( $size =~ /^\d+$/ ) {
} else {
    die "$size is not an integer";
}

open(OUT, "> $file")
    || die "Cannot open $file";

while ( 1 ) {
    my $buffer = "";
    my $r = read STDIN, $buffer, 16384;
    die "Read error" if !defined($r);
    last if $r == 0;
    $count += $r;
    if ( $count <= $size ) {
        print OUT $buffer;
        print $buffer;
    } else {
        # print complement to $size:
        $buffer = substr $buffer, 0, length($r)-($count-$size);
        print OUT $buffer;
        print $buffer;
        # Print warning:
        my $msg = "<p class=\"WARNING\">[NOTE: 
Votre sortie outrepasse les $size octets prvus. 
J'ignore les octets en trop! ] </p>
";
        print OUT $msg;
        print $msg;
        last;
    }
}

# end of tee_head.pl
