#! /usr/bin/perl

sub gcd {
    my($p, $q) = @_;
    if ( $p > $q ) {
        ($p, $q) = ($q, $p);
    };
    while ( $p != 0 ) {
        ($p, $q) = ( $q % $p, $p);
    }
    return $q;
}

sub lcm {
    my($p, $q) = @_;
    return ($p * $q)/gcd($p, $q);
}

$last = <STDIN>;
while ( <STDIN> ) {
    $last = lcm($last, $_);
    print $last, "\n";
}

# end of mulppcm.pl
